SystemOrganization addCategory: #'JiffyCard-Core'!

Object subclass: #JCCounterCount
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCounterCount methodsFor: 'accessing' stamp: 'chc 10/13/2017 07:45'!
count

	^ count! !

!JCCounterCount methodsFor: 'accessing' stamp: 'chc 10/13/2017 07:45'!
count: anObject

	count := anObject! !

!JCCounterCount methodsFor: 'as yet unclassified' stamp: 'chc 10/13/2017 07:45'!
decrement
	count := count - 1! !

!JCCounterCount methodsFor: 'as yet unclassified' stamp: 'chc 10/13/2017 07:45'!
increment
	count := count + 1! !

!JCCounterCount methodsFor: 'as yet unclassified' stamp: 'chc 10/13/2017 07:45'!
initialize
	count := 0! !

Object subclass: #JCPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCPresenter subclass: #JCComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCComponent subclass: #JCCard
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner

	^ owner! !

!JCCard methodsFor: 'accessing' stamp: 'chc 7/5/2017 07:22'!
owner: anObject

	owner := anObject! !

JCCard subclass: #JCSelectASushi
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCSelectASushi methodsFor: 'accessing' stamp: 'chc 12/20/2017 09:02'!
initialize 
	cart := JCStoreCartView new cart: (WAStoreCart new).
	item := (WAStoreInventory default findItem: 'Kisu') first.
! !

!JCSelectASushi methodsFor: 'as yet unclassified' stamp: 'chc 12/20/2017 09:00'!
renderContentOn: html
	html p: cart.
	html a callback: [ cart add: item ]; with: 'Add'.! !

JCCard subclass: #JCStore
	instanceVariableNames: 'frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCStore methodsFor: 'as yet unclassified' stamp: 'chc 11/29/2017 11:49'!
initialize
	frame := JCStoreFillCart new.
! !

!JCStore methodsFor: 'as yet unclassified' stamp: 'chc 11/29/2017 12:16'!
renderContentOn: html
	html div id: 'banner'; with: [
	html div id: 'title'; with: [ html text: 'sushiNet' ].
	html div id: 'subtitle'; with: [ html text: 'fresh, raw fish delivered to your door']].
	
	html div id: 'one'; with: frame.
	"html a callback: [ self frame: JCSelectASushi new]; with: 'Browse'.
	html br. 
	html a callback: [owner call: JCStoreCartConfirmation new]; with: 'Checkout'."! !

JCCard subclass: #JCStoreCartConfirmation
	instanceVariableNames: 'integer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
initialize
	integer := 0! !

!JCStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'chc 11/17/2017 14:26'!
renderContentOn: html
	html p: 'Buy $2.50 worth of sushi?'.
	html form beMethodGet; with:
		[html input 
			beTypeText
			value: integer printString;
			callback: [:str | integer := str asNumber];
			with: [].
		html text: integer asWords]! !

!JCStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'chc 7/5/2017 07:26'!
renderStyleOn: html
	html style: 'input {margin-right: 20px}'! !

JCCard subclass: #JCStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCStoreCartView methodsFor: 'accessing' stamp: 'chc 12/20/2017 09:04'!
add: anObject
	cart add: anObject! !

!JCStoreCartView methodsFor: 'accessing' stamp: 'chc 12/4/2017 10:45'!
cart

	^ cart! !

!JCStoreCartView methodsFor: 'accessing' stamp: 'chc 12/4/2017 10:45'!
cart: anObject

	cart := anObject! !

!JCStoreCartView methodsFor: 'as yet unclassified' stamp: 'chc 12/20/2017 08:49'!
renderContentOn: html
	cart hasItems 
		ifTrue: [ html p: 'Cart has items']
		ifFalse: [ ^self ]! !

JCCard subclass: #JCStoreFillCart
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCStoreFillCart methodsFor: 'as yet unclassified' stamp: 'chc 12/20/2017 09:02'!
initialize
	main := JCStoreInfo new! !

!JCStoreFillCart methodsFor: 'as yet unclassified' stamp: 'chc 12/20/2017 08:59'!
renderContentOn: html
html table: [
	html tr: [
		html td: [ html div id: 'navbar'; with: [ self renderNavBar: html ]].
		html td: [ html div id: 'two'; with: main ].
		]]! !

!JCStoreFillCart methodsFor: 'as yet unclassified' stamp: 'chc 12/20/2017 08:58'!
renderNavBar: html 
	html p: 'Hello NavBar'.
	html a callback: [ main := JCSelectASushi new ]; with: 'Browse'.! !

JCCard subclass: #JCStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCStoreInfo methodsFor: 'as yet unclassified' stamp: 'chc 11/23/2017 08:46'!
renderContentOn: html
	html p: 'Welcome to the sushiNet online store.'.
	html p: 'This is a sample Seaside application.'.
	html p: 'Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".'! !

JCCard subclass: #JCStoreItemView
	instanceVariableNames: 'cart item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

JCStoreItemView class
	instanceVariableNames: 'cart'!

JCStoreItemView class
	instanceVariableNames: 'cart'!

!JCStoreItemView class methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:37'!
cart

	^ cart! !

!JCStoreItemView class methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:37'!
cart: anObject

	cart := anObject! !

!JCStoreItemView methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:10'!
cart

	^ cart! !

!JCStoreItemView methodsFor: 'accessing' stamp: 'chc 9/29/2017 08:10'!
cart: anObject

	cart := anObject! !

!JCStoreItemView methodsFor: 'accessing' stamp: 'chc 11/16/2017 14:16'!
item: anObject

	item := anObject! !

!JCStoreItemView methodsFor: 'as yet unclassified' stamp: 'chc 11/17/2017 14:18'!
renderContentOn: html
	html p: 'Sushi Item'.
	html p: item title.
	html p: item subtitle.
	html p: item description.
	html p: item price printString.
	
	html a callback: [ cart add: item ]; with: 'Add'.
	html br. 
	html a callback: [ self answer ]; with: 'Cancel'! !

!JCComponent methodsFor: 'decorations' stamp: 'chc 6/30/2017 09:27'!
addDecoration: newDecoration
	| dec |
	dec _ self decoration.
	newDecoration next: dec.
	self decoration: newDecoration! !

!JCComponent methodsFor: 'call/answer' stamp: 'chc 7/12/2017 05:46'!
answer 
	self owner removeDecoration! !

!JCComponent methodsFor: 'call/answer' stamp: 'chc 7/6/2017 07:41'!
call: anObject
	|decoration|
	anObject owner: self.
	decoration := JCDelegation new delegate: anObject. 
	self addDecoration: decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration
	^ decoration! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 6/30/2017 09:27'!
decoration: anObject
	decoration := anObject! !

!JCComponent methodsFor: 'accessing' stamp: 'chc 9/28/2017 07:45'!
initialize
	decoration := self.
	! !

!JCComponent methodsFor: 'decorations' stamp: 'chc 6/30/2017 09:27'!
removeDecoration
	| owner |
	owner _ self decoration next.
	self decoration: owner! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 4/26/2017 10:05'!
renderContentOn: anObject
	self subclassResponsibility ! !

!JCComponent methodsFor: 'as yet unclassified' stamp: 'chc 7/11/2017 07:31'!
renderOn: anObject
	(decoration isNil) 
		ifTrue: [self renderContentOn: anObject]
		ifFalse: [decoration renderContentOn: anObject]! !

JCComponent subclass: #JCDeck
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeck methodsFor: 'converting' stamp: 'chc 6/29/2017 07:08'!
asResource
	^ JCHtmlResource component: self! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 9/20/2017 09:05'!
initialize
	self call: self firstCard! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 6/29/2017 07:08'!
renderBodyOn: html
	html div
		with: [decoration renderOn: html]! !

!JCDeck methodsFor: 'rendering' stamp: 'chc 11/29/2017 12:24'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'Altitude Sushi Store'.
			 html style: 
				'#border {
					border: thin solid #aaa;
					margin-left: 8px;
					margin-right: 8 px;}
				#banner { background-color: lightblue;
					text-align: right;}
				#title { font-size: 18pt; 
						font-weight: bold;}
				#subtitle { font-size: 9pt;
						font-style: italic;}
				#navbar { background-color: lightgrey;}
					
					'].
	html body: [ self renderBodyOn: html ] ]! !

JCDeck subclass: #JCDeckOne
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDeckOne methodsFor: 'as yet unclassified' stamp: 'chc 11/28/2017 08:29'!
firstCard
 	^JCStore new
	   ! !

JCPresenter subclass: #JCDecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next

	^ next! !

!JCDecoration methodsFor: 'accessing' stamp: 'chc 5/21/2017 21:14'!
next: anObject

	next := anObject! !

!JCDecoration methodsFor: 'as yet unclassified' stamp: 'chc 5/21/2017 21:10'!
renderContentOn: anObject
	self subclassResponsibility ! !

JCDecoration subclass: #JCDelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCDelegation commentStamp: 'chc 5/30/2017 13:31' prior: 0!
This is a different kind of decoration. Instead of adding content or a window, which will pass on to the next decoration or the owner in the #next ivar. There is a component in the delegate ivar that replaces the original owner component. When this decoration is removed the original owner re-renders. 

It needs to go one step further. The delegate needs to be passed a self delegate reference (see Kent Beck "Smalltalk Best Practices") so that the component can have an anchor that can reach this decoration to send #remove. !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate

	^ delegate! !

!JCDelegation methodsFor: 'accessing' stamp: 'chc 5/30/2017 13:21'!
delegate: anObject

	delegate := anObject! !

!JCDelegation methodsFor: 'as yet unclassified' stamp: 'chc 5/30/2017 13:21'!
renderContentOn: html 
	html render: delegate! !

!JCPresenter methodsFor: 'rendering' stamp: 'chc 5/30/2017 12:51'!
renderOn: html
	"( self respondsTo: #decoration)
		ifTrue: [  self decoration renderContentOn: html   ]
		ifFalse: [ " self renderContentOn: html   " ]"! !

!ALReference methodsFor: '*jiffycard-core' stamp: 'chc 11/20/2017 09:29'!
add: anObject
	value add: anObject! !

!ALReference methodsFor: '*jiffycard-core' stamp: 'chc 11/20/2017 09:34'!
countsAndItems
	^value countsAndItems! !

!ALReference methodsFor: '*jiffycard-core' stamp: 'chc 11/7/2017 09:44'!
hasItems
	^value hasItems ! !

!ALReference methodsFor: '*jiffycard-core' stamp: 'chc 11/7/2017 09:46'!
increment
	value add: (WAStoreItem new title: 'Mako')! !

!ALReference methodsFor: '*jiffycard-core' stamp: 'chc 11/8/2017 10:32'!
items
	^value items! !

ALComponentResource subclass: #JCHtmlResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:49'!
handleGet: aRequest locator: aLocator
	| response |
	response := self respondHtmlLocator: aLocator.
	response vary: (ALStrings with: 'Accept').
	^ response! !

!JCHtmlResource methodsFor: 'as yet unclassified' stamp: 'chc 4/18/2017 14:48'!
respondHtmlLocator: aLocator
	 ^ ALResponse 
		type: ALContentType html 
		callback: 
			[:out || context |
			context := ALRenderingContext resource: self locator: aLocator.
			component renderHtmlOn: (ALAppHtml5Canvas context: context stream: out)]! !

ALApplication subclass: #JiffyCardApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JiffyCard-Core'!

!JiffyCardApplication methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2017 07:22'!
initializeLocator
	locator 
		at: ALPath root 
		put: JCDeckOne new asResource
		
	
	" (JCMessage new message: 'The Ghost In The Machine')"! !
